Index: BasicCompiler_Common/BasicFixed.h
===================================================================
--- BasicCompiler_Common/BasicFixed.h	(revision 69)
+++ BasicCompiler_Common/BasicFixed.h	(revision 99)
@@ -129,55 +129,57 @@
 
 //以下制御用エスケープシーケンス
-#define ESC_MOD			'1'	//MOD 演算子
-#define ESC_AND			'&'	//AND 演算子
-#define ESC_OR			'3'	//OR 演算子
-#define ESC_XOR			'4'	//XOR 演算子
-#define ESC_NOT			'5'	//NOT 演算子
-#define ESC_AS			'6'	//AS（区切り文字）
-#define ESC_THEN		2	//Then
-#define ESC_ELSE		3	//Else
-#define ESC_IF			'A'	//If
-#define ESC_ELSEIF		'B'	//ElseIf
-#define ESC_ENDIF		'C'	//End If
-#define ESC_DEF			'D'	//Def
-#define ESC_DECLARE		'E'	//Declare
-#define ESC_SUB			'F'	//Sub
-#define ESC_ENDSUB		'G'	//End Sub
-#define ESC_EXITSUB		'H'	//Exit Sub
-#define ESC_FUNCTION	'I'	//Function
-#define ESC_ENDFUNCTION	'J'	//End Function
-#define ESC_EXITFUNCTION 'K'//Exit Function
-#define ESC_BYVAL		'L'	//ByVal
-#define ESC_BYREF		'M'	//ByRef
-#define ESC_TYPE		'N'	//Type
-#define ESC_ENDTYPE		'O'	//End Type
-#define ESC_EXITFOR		'P'	//Exit For
-#define ESC_EXITWHILE	'Q'	//Exit Wend
-#define ESC_EXITDO		'R'	//Exit Do
-#define ESC_SELECTCASE	'S'	//Select Case
-#define ESC_CASE		'T'	//Case
-#define ESC_CASEELSE	'U'	//Case Else
-#define ESC_ENDSELECT	'V'	//End Select
-#define ESC_CONST		'W'	//Const
-#define ESC_WITH		'X' //With
-#define ESC_ENDWITH		'Y'	//End With
-#define ESC_CDECL		'Z'	//cdecl規約
-#define ESC_MACRO		'a' //Macro
-#define ESC_ENDMACRO	'b'	//End Macro
-#define ESC_EXITMACRO	'c'	//Exit Macro
-#define ESC_EXPORT		'd'	//Export
-#define ESC_CONTINUE	'e'	//Continue
-#define ESC_PSMEM		'f'	//"->" Member of Pointer Struct（構造体ポインタのメンバ参照）
-#define ESC_STATIC		'g'	//Static
-#define ESC_TYPEDEF		'h'	//TypeDef
-#define ESC_TRY			'i'	//Try
-#define ESC_CATCH		'j'	//Catch
-#define ESC_FINALLY		'k'	//Finally
-#define ESC_THROW		'l'	//Throw
-#define ESC_ENDTRY		'm'	//End Try
+#define ESC_MOD				'1'		// MOD 演算子
+#define ESC_AND				'&'		// AND 演算子
+#define ESC_OR				'3'		// OR 演算子
+#define ESC_XOR				'4'		// XOR 演算子
+#define ESC_NOT				'5'		// NOT 演算子
+#define ESC_AS				'6'		// AS（区切り文字）
+#define ESC_THEN			2		// Then
+#define ESC_ELSE			3		// Else
+#define ESC_IF				'A'		// If
+#define ESC_ELSEIF			'B'		// ElseIf
+#define ESC_ENDIF			'C'		// End If
+#define ESC_DEF				'D'		// Def
+#define ESC_DECLARE			'E'		// Declare
+#define ESC_SUB				'F'		// Sub
+#define ESC_ENDSUB			'G'		// End Sub
+#define ESC_EXITSUB			'H'		// Exit Sub
+#define ESC_FUNCTION		'I'		// Function
+#define ESC_ENDFUNCTION		'J'		// End Function
+#define ESC_EXITFUNCTION	'K'		// Exit Function
+#define ESC_BYVAL			'L'		// ByVal
+#define ESC_BYREF			'M'		// ByRef
+#define ESC_TYPE			'N'		// Type
+#define ESC_ENDTYPE			'O'		// End Type
+#define ESC_EXITFOR			'P'		// Exit For
+#define ESC_EXITWHILE		'Q'		// Exit Wend
+#define ESC_EXITDO			'R'		// Exit Do
+#define ESC_SELECTCASE		'S'		// Select Case
+#define ESC_CASE			'T'		// Case
+#define ESC_CASEELSE		'U'		// Case Else
+#define ESC_ENDSELECT		'V'		// End Select
+#define ESC_CONST			'W'		// Const
+#define ESC_WITH			'X'		// With
+#define ESC_ENDWITH			'Y'		// End With
+#define ESC_CDECL			'Z'		// cdecl規約
+#define ESC_MACRO			'a'		// Macro
+#define ESC_ENDMACRO		'b'		// End Macro
+#define ESC_EXITMACRO		'c'		// Exit Macro
+#define ESC_EXPORT			'd'		// Export
+#define ESC_CONTINUE		'e'		// Continue
+#define ESC_PSMEM			'f'		// "->" Member of Pointer Struct（構造体ポインタのメンバ参照）
+#define ESC_STATIC			'g'		// Static
+#define ESC_TYPEDEF			'h'		// TypeDef
+#define ESC_TRY				'i'		// Try
+#define ESC_CATCH			'j'		// Catch
+#define ESC_FINALLY			'k'		// Finally
+#define ESC_THROW			'l'		// Throw
+#define ESC_ENDTRY			'm'		// End Try
+#define ESC_NAMESPACE		'o'		// Namespace
+#define ESC_ENDNAMESPACE	'p'		// End Namespace
 //EXEファイル用制御エスケープシーケンス
-#define ESC_USING		'o'	//Print命令語のUsing
-#define ESC_FOR			'p'	//Open命令語のFor
-#define ESC_LINENUM		'q'	//行番号を示す
+#define ESC_USING			'q'		// Print命令語のUsing
+#define ESC_FOR				'r'		// Open命令語のFor
+#define ESC_LINENUM			's'		// 行番号を示す
 
 //オブジェクト指向エスケープシーケンス