Index: Include/Classes/System/Collections/misc.ab
===================================================================
--- Include/Classes/System/Collections/misc.ab	(revision 55)
+++ Include/Classes/System/Collections/misc.ab	(revision 118)
@@ -4,12 +4,9 @@
 #define __SYSTEM_COLLECTIONS_MISC_AB__
 
-Interface IObject
-End Interface
-
 Interface ICollection
-	Inherits /* IObject, */IEnumerable
+	Inherits IEnumerable
 	' Properties
-	Const Function Count() As Long
-	Const Function IsSynchronized() As BOOL
+	'/*Const*/ Function Count() As Long
+	'/*Const*/ Function IsSynchronized() As Boolean
 	' Function SyncRoot() As ...
 	' Methods
@@ -18,24 +15,23 @@
 
 Interface IComparer
-	Inherits IObject
 	' Methods
-	Function Compare(ByRef x As IObject, ByRef y As IObject) As Long
+	Function Compare(ByRef x As Object, ByRef y As Object) As Long
 End Interface
 
 Interface IDictionary
-	Inherits /*IObject, */ ICollection /*, IEnumerable */
+	Inherits ICollection /*, IEnumerable */
 	' Methods
-	Sub Add(ByRef key As IObject, ByRef value As IObject)
+	Sub Add(ByRef key As Object, ByRef value As Object)
 	Sub Clear()
-	Const Function Contains(ByRef key As IObject) As BOOL
-	Const Function GetEnumerator() As *IDictionaryEnumerator
-	Const Function Remove(ByRef key As IObject) As BOOL
+	/*Const*/ Function Contains(ByRef key As Object) As Boolean
+'	/*Const*/ Function GetEnumerator() As *IDictionaryEnumerator
+	/*Const*/ Function Remove(ByRef key As Object) As Boolean
 	' Properties
-	Const Function IsFixedSize() As BOOL
-	Const Function IsReadOnly() As BOOL
-	Const Function Operator [](ByRef key As IObject) As *IObject
-	Sub Operator []=(ByRef key As IObject, ByRef value As IObject)
-	Const Function Keys() As *ICollection
-	Const Function Values() As ICollection
+	/*Const*/ Function IsFixedSize() As Boolean
+	/*Const*/ Function IsReadOnly() As Boolean
+'	/*Const*/ Function Operator [](ByRef key As Object) As *Object
+'	Sub Operator []=(ByRef key As Object, ByRef value As Object)
+	/*Const*/ Function Keys() As *ICollection
+	/*Const*/ Function Values() As ICollection
 End Interface
 
@@ -43,29 +39,26 @@
 	Inherits IEnumerator
 	' Properties
-	Const Function Entry() As DictionaryEntry
-	Const Function Key() As *IObject
-	Const Function Value() As *IObject
+	/*Const*/ Function Entry() As DictionaryEntry
+	/*Const*/ Function Key() As *Object
+	/*Const*/ Function Value() As *Object
 End Interface
 
 Interface IEnumerable
-	Inherits IObject
 	' Method
-	Function GetEnumerator() As *IEnumerator
+'	Function GetEnumerator() As *IEnumerator
 End Interface
 
 Interface IEnumerator
-	Inherits IObject
 	' Methods
-	Function MoveNext() As BOOL
+	Function MoveNext() As Boolean
 	Sub Reset()
 	' Property
-	Function Current() As *IObject
+	Function Current() As *Object
 End Interface
 
 Interface IEqualityComparer
-	Inherits IObject
 	' Methods
-	Function Equals(ByRef x As Object, ByRef y As Object) As BOOL
-	Function GetHashCode(ByRef obj As IObject) As Long
+	Function Equals(ByRef x As Object, ByRef y As Object) As Boolean
+	Function GetHashCode(ByRef obj As Object) As Long
 End Interface
 
@@ -73,22 +66,21 @@
 	Inherits ICollection /*, IEnumerable */
 	' Methods
-	Function Add(ByRef value As IObject) As Long
-	Sub Clear()
-	Const Function Contains(ByRef value As IObject) As BOOL
-	Const Function IndexOf(ByRef value As IObject) As Long
-	Sub Insert(index As Long, ByRef value As IObject)
-	Sub Remove(ByRef value As IObject)
+	'Function Add(value As *Object) As Long
+	'Sub Clear()
+	'/*Const*/ Function Contains(value As *Object) As Boolean
+	/*Const*/ Function IndexOf(value As *Object) As Long
+	Sub Insert(index As Long, value As *Object)
+	Sub Remove(value As *Object)
 	Sub RemoveAt(index As Long)
 	' Properties
-	Const Function IsFixedSize() As BOOL
-	Const Function IsReadOnly() As BOOL
-	Const Function Operator [](index As Long) As *IObject
-	Const Sub Operator []=(index As Long, ByRef obj As IObject)
+	/*Const*/ Function IsFixedSize() As Boolean
+	/*Const*/ Function IsReadOnly() As Boolean
+	'/*Const*/ Function Operator [](index As Long) As *Object
+	'/*Const*/ Sub Operator []=(index As Long, obj As *Object)
 End Interface
 
 Class DictionaryEntry
-	Inherits IObject
 Public
-	' Constructors
+	' /*Const*/ructors
 	Sub DictionaryEntry()
 		k = 0
@@ -96,5 +88,5 @@
 	End Sub
 
-	Sub DictionaryEntry(ByRef key As IObject, ByRef value As IObject)
+	Sub DictionaryEntry(ByRef key As Object, ByRef value As Object)
 		k = VarPtr(key)
 		v = VarPtr(value)
@@ -102,22 +94,22 @@
 
 	' Properties
-	Const Function Key() As *IObject
+	/*Const*/ Function Key() As *Object
 		Return k
 	End Function
 
-	Sub Key(ByRef key As IObject)
+	Sub Key(ByRef key As Object)
 		k = VarPtr(key)
 	End Sub
 
-	Const Function Value() As *IObject
+	/*Const*/ Function Value() As *Object
 		Return v
 	End Function
 
-	Sub Value(ByRef value As IObject)
+	Sub Value(ByRef value As Object)
 		v = VarPtr(value)
 	End Sub
 Private
-	k As *IObject
-	v As *IObject
+	k As *Object
+	v As *Object
 End Class
 